/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package view;

import dao.Conexao;
import dao.OrdemServicoDAO;
import static java.lang.Integer.parseInt;
import java.sql.Connection;
import java.util.HashMap;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import model.OSModel;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.view.JasperViewer;

/**
 *
 * @author PauloGouveia
 */
public class BuscaOrdemServico extends javax.swing.JFrame {
    Connection conexao = null;
    Conexao con = new Conexao();
    
    /**
     * Creates new form BuscaOrdemServico
     */
    public BuscaOrdemServico() {
        initComponents();
       conexao = con.criarConexao();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TabelaDeServicos = new javax.swing.JTable();
        buscarServicoBtn = new javax.swing.JButton();
        deleteBtn = new javax.swing.JButton();
        PrintBtn = new javax.swing.JButton();
        codigoServicoTxt = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        voltarBtn1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("LISTA DE OS");
        setResizable(false);

        jPanel2.setBackground(new java.awt.Color(4, 4, 21));

        jPanel3.setBackground(new java.awt.Color(0, 102, 102));

        jLabel1.setFont(new java.awt.Font("Baskerville Old Face", 3, 36)); // NOI18N
        jLabel1.setText("Lista de Serviços");
        jLabel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(403, Short.MAX_VALUE)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 287, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(289, 289, 289))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addComponent(jLabel1)
                .addContainerGap(35, Short.MAX_VALUE))
        );

        TabelaDeServicos.setBackground(new java.awt.Color(0, 153, 153));
        TabelaDeServicos.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        TabelaDeServicos.setFont(new java.awt.Font("Baskerville Old Face", 1, 14)); // NOI18N
        TabelaDeServicos.setForeground(new java.awt.Color(255, 255, 255));
        TabelaDeServicos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Código serviço", "Nome Cliente", "CPF", "Endereço", "Bairro", "Defeito", "Data chegada", "Previsão de Entrega", "Valor da entrada", "Observação"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        TabelaDeServicos.setAutoscrolls(false);
        TabelaDeServicos.setGridColor(new java.awt.Color(0, 102, 102));
        TabelaDeServicos.setRequestFocusEnabled(false);
        TabelaDeServicos.setSelectionBackground(new java.awt.Color(0, 102, 102));
        TabelaDeServicos.setSelectionForeground(new java.awt.Color(255, 255, 255));
        TabelaDeServicos.setShowHorizontalLines(true);
        TabelaDeServicos.setShowVerticalLines(true);
        jScrollPane1.setViewportView(TabelaDeServicos);

        buscarServicoBtn.setBackground(new java.awt.Color(0, 102, 102));
        buscarServicoBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/Search_24px.png"))); // NOI18N
        buscarServicoBtn.setText("Busca");
        buscarServicoBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buscarServicoBtnActionPerformed(evt);
            }
        });

        deleteBtn.setBackground(new java.awt.Color(0, 102, 102));
        deleteBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/Trash_24px.png"))); // NOI18N
        deleteBtn.setText("Excluir");
        deleteBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteBtnActionPerformed(evt);
            }
        });

        PrintBtn.setBackground(new java.awt.Color(0, 102, 102));
        PrintBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/Print_25px.png"))); // NOI18N
        PrintBtn.setText("Imprimir");
        PrintBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrintBtnActionPerformed(evt);
            }
        });

        codigoServicoTxt.setToolTipText("EM CASO DE DELETAR INFORMAR O CODIGO DA VENDA");
        codigoServicoTxt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                codigoServicoTxtActionPerformed(evt);
            }
        });

        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Codigo Serviço");

        voltarBtn1.setBackground(new java.awt.Color(0, 102, 102));
        voltarBtn1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/Restart_24px.png"))); // NOI18N
        voltarBtn1.setText("Voltar");
        voltarBtn1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                voltarBtn1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(buscarServicoBtn)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                            .addGap(167, 167, 167)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel2Layout.createSequentialGroup()
                            .addGap(159, 159, 159)
                            .addComponent(codigoServicoTxt, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(57, 57, 57)
                        .addComponent(deleteBtn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 122, Short.MAX_VALUE)
                        .addComponent(voltarBtn1, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(57, 57, 57)
                .addComponent(PrintBtn)
                .addGap(146, 146, 146))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(32, 32, 32)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(codigoServicoTxt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(deleteBtn)
                    .addComponent(buscarServicoBtn)
                    .addComponent(PrintBtn)
                    .addComponent(voltarBtn1))
                .addGap(0, 0, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 20, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buscarServicoBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buscarServicoBtnActionPerformed
        OrdemServicoDAO servicoDao = new OrdemServicoDAO();

        List<OSModel> lista;
        lista = servicoDao.listarTodosServiços();

        DefaultTableModel modeloPadrao = (DefaultTableModel) TabelaDeServicos.getModel();
        for (OSModel servico : lista) {
            modeloPadrao.addRow(new Object[]{
                servico.getIdServico(),
                servico.getNomeCliente(),
                servico.getCpf(),
                servico.getEndereco(),
                servico.getBairro(),
                servico.getDefeito(),
                servico.getDataChegada(),
                servico.getDataEntrega(),
                servico.getValorEntrada(),
                servico.getObservacao()
                

            });
        }
    }//GEN-LAST:event_buscarServicoBtnActionPerformed

    private void deleteBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteBtnActionPerformed

        int resposta = JOptionPane.showConfirmDialog(null, "Deseja realmente excluir?","Atenção!!", JOptionPane.YES_NO_OPTION);

        if (resposta == JOptionPane.YES_OPTION && TabelaDeServicos.getSelectedRow()!= -1) {

            OrdemServicoDAO servicoDao = new OrdemServicoDAO();
            OSModel servico = new OSModel();

            servico.setIdServico(parseInt(codigoServicoTxt.getText()));

            servicoDao.ExcluirServico(servico);

            JOptionPane.showMessageDialog(this, "Exclusão feita com sucesso!!","Atenção!!", WIDTH);
            DefaultTableModel modeloPadrao = (DefaultTableModel) TabelaDeServicos.getModel();
            modeloPadrao.removeRow(TabelaDeServicos.getSelectedRow());

        } else if (resposta == JOptionPane.YES_OPTION && TabelaDeServicos.getSelectedRow()== -1) {
            JOptionPane.showMessageDialog(this, "Primeiro selecione uma linha!!","Atenção!!", WIDTH);

        }

        else if(resposta == JOptionPane.NO_OPTION ){
            JOptionPane.showMessageDialog(this,"Cancelada a exclusão!!","Atenção!!", WIDTH);
        }

    }//GEN-LAST:event_deleteBtnActionPerformed

    private void PrintBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrintBtnActionPerformed
       
        int confirma = JOptionPane.showConfirmDialog(null,"deseja imprimir o relatório?","Atenção!!",JOptionPane.YES_NO_OPTION);
        
        if(confirma == JOptionPane.YES_OPTION && codigoServicoTxt.getText() != null){
           
            try {
                HashMap parametros = new HashMap();
                parametros.put("ID",codigoServicoTxt.getText());
                
                JasperPrint print = JasperFillManager.fillReport("C:/Users/PauloGouveia/Documents/NetBeansProjects/CasaDaPelicula/src/relatorios/Ordem de Serviço.jasper",parametros,conexao);
                
                JasperViewer.viewReport(print,false);
            } catch (JRException e) {
                
               JOptionPane.showMessageDialog(this, "Insira o numero da ordem de serviço!!",""+e,WIDTH);
            }
          
        }else if(confirma == JOptionPane.NO_OPTION){
            JOptionPane.showMessageDialog(this,"Impressão Cancelada!!","Atenção!!",WIDTH);
        }     
   
        
    }//GEN-LAST:event_PrintBtnActionPerformed

    private void codigoServicoTxtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_codigoServicoTxtActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_codigoServicoTxtActionPerformed

    private void voltarBtn1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_voltarBtn1ActionPerformed
        this.dispose();
    }//GEN-LAST:event_voltarBtn1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(BuscaOrdemServico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(BuscaOrdemServico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(BuscaOrdemServico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BuscaOrdemServico.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BuscaOrdemServico().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton PrintBtn;
    private javax.swing.JTable TabelaDeServicos;
    private javax.swing.JButton buscarServicoBtn;
    private javax.swing.JTextField codigoServicoTxt;
    private javax.swing.JButton deleteBtn;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton voltarBtn1;
    // End of variables declaration//GEN-END:variables
}
